org.apache.commons.io.comparator

## Class DirectoryFileComparator

- java.lang.Object
- - org.apache.commons.io.comparator.AbstractFileComparator
  - - org.apache.commons.io.comparator.DirectoryFileComparator

- All Implemented Interfaces:
    Serializable, Comparator<File>

      public class DirectoryFileComparator
      extends AbstractFileComparator
      implements Serializable

  Compare two files using the `File.isDirectory()` method.

  This comparator can be used to sort lists or arrays by directories and files.

  Example of sorting a list of files/directories using the `DIRECTORY_COMPARATOR` singleton instance:

             List<File> list = ...
             ((AbstractFileComparator) DirectoryFileComparator.DIRECTORY_COMPARATOR).sort(list);

  Example of doing a reverse sort of an array of files/directories using the `DIRECTORY_REVERSE` singleton instance:

             File[] array = ...
             ((AbstractFileComparator) DirectoryFileComparator.DIRECTORY_REVERSE).sort(array);

  ## Deprecating Serialization

  Serialization is deprecated and will be removed in 3.0.

  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static Comparator<File>` | `DIRECTORY_COMPARATOR` Singleton default comparator instance
    `static Comparator<File>` | `DIRECTORY_REVERSE` Singleton reverse default comparator instance

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DirectoryFileComparator()` Construct a new instance.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `compare(File file1, File file2)` Compares the two files using the `File.isDirectory()` method.

    - ### Methods inherited from class org.apache.commons.io.comparator.AbstractFileComparator

      `sort, sort, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.Comparator

      `comparing, comparing, comparingDouble, comparingInt, comparingLong, equals, naturalOrder, nullsFirst, nullsLast, reversed, reverseOrder, thenComparing, thenComparing, thenComparing, thenComparingDouble, thenComparingInt, thenComparingLong`

- - ### Field Detail

    - #### DIRECTORY_COMPARATOR

          public static final Comparator<File> DIRECTORY_COMPARATOR

      Singleton default comparator instance

    - #### DIRECTORY_REVERSE

          public static final Comparator<File> DIRECTORY_REVERSE

      Singleton reverse default comparator instance

  - ### Constructor Detail

    - #### DirectoryFileComparator

          public DirectoryFileComparator()

      Construct a new instance.

  - ### Method Detail

    - #### compare

          public int compare(File file1,
                             File file2)

      Compares the two files using the `File.isDirectory()` method.
      Specified by:
        `compare` in interface `Comparator<File>`
      Parameters:
        `file1` - The first file to compare.
        `file2` - The second file to compare.
      Returns:
        the result of calling file1's `File.compareTo(File)` with file2 as the parameter.